#include "FIRFilter.h"
#include "Decimator.h"
#include "Interpolator.h"
#include "SinGen.h"

class Detector {
  
private:
  Decimator *iDecimator, *qDecimator;
  Interpolator *interpolator;
  FIRFilter *iFilter, *qFilter;
  FIRFilter *in_Filter;
  SinGen *bfo;
  float ifreq;
  
  void filter_init(void);
  
public:
  int mode;
  int detecting;
  
  Detector(void) {
    bfo = new SinGen(12000.0f, 48000);
    mode = 0;
    filter_init();
  }
  void detect(float *input, float *output, int n_samples);
  void set_iqfilter(float sf, float f1, float f2, float trband, float attn);
  void set_ifreq(float freq);
};

