/*
 * complex sine wave generator
 */

#ifndef SINGEN_H
#define SINGEN_H

#include <math.h>
#include <stdio.h>
#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

class SinGen {

 private:
  int sr;
  float f;
  float amp;
  double a, b, c, d;
  double angle, wd;
  
 public:
  SinGen(float freq, int sample_rate) {
    sr = sample_rate;
    f = freq;
    amp = 1.0;
    a = 1.0;
    b = 0.0;
    angle = 0.0;
    wd = 2 * M_PI * f / sr;
    c = cos(wd);
    d = sin(wd);
  }
  SinGen(float freq, int sample_rate, float amplitude) {
    sr = sample_rate;
    f = freq;
    if (amplitude > 1.0 || amplitude <= 0) {
      amp = 1.0;
    } else {
      amp = amplitude;
    }
    a = 1.0;
    b = 0.0;
    angle = 0.0;
    wd = 2 * M_PI * f / sr;
    c = cos(wd);
    d = sin(wd);
  }
  void set_freq(float freq) {
    //fprintf(stderr, "setting freq: %.0f\n", freq);
    f = freq;
    wd = 2 * M_PI * f / sr;
    c = cos(wd);
    d = sin(wd);
  }
  //void get_sample(void);
  void get_sample_n(float *i, float *q, int n);
};

#endif
